/* libsocket++ - Socket abstraction library for C++
 *  Copyright (C) 2002  Simon Richter
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  $Id: builddSocketTCP.h,v 1.2 2002/04/15 17:14:17 geier Exp $
 */

#include <socket++/Socket.h>

namespace socketxx {

class SocketTCP : public Socket {
	public:
		SocketTCP(void);
	private:
		SocketTCP(int fd);
	public:
		virtual ~SocketTCP(void);

	public:
		virtual Socket *accept(void);
		virtual void bind(const std::string &);
		virtual void connect(const std::string &);

	private:
		class TypeTCP : public Type {
			private:
				TypeTCP(void);
			public:
				virtual ~TypeTCP(void);

			public:
				virtual const std::string &getType(void) const;
				virtual Socket *operator()
					(void) const;

				static const std::string typetcpname;
				static TypeTCP typetcp;
		};
};

}
